#include "GtFVF.h"
#include<windows.h>
#include<assert.h>

GtFVF::GtFVF() : m_pOriginal(NULL), m_FVF_Value(0), m_FVF_Size(0), m_pCalc(NULL), m_pNext(NULL)
{
}

GtFVF::~GtFVF()
{
}

int GtFVF::FVF_Get_Total_Size(unsigned long _value)
{
	int size = 0;

	if(IsFVF(GT_FVF_XYZ))			size += sizeof(sGT_FVF_XYZ);
	else if(IsFVF(GT_FVF_XYZRHW))   size += sizeof(sGT_FVF_XYZRHW);
	else if(IsFVF(GT_FVF_XYZB1))    size += sizeof(sGT_FVF_XYZB1);
	else if(IsFVF(GT_FVF_XYZB2))    size += sizeof(sGT_FVF_XYZB2);
	else if(IsFVF(GT_FVF_XYZB3))    size += sizeof(sGT_FVF_XYZB3);
	else if(IsFVF(GT_FVF_XYZB4))    size += sizeof(sGT_FVF_XYZB4);
	else if(IsFVF(GT_FVF_XYZB5))    size += sizeof(sGT_FVF_XYZB5);

	if(IsFVF(GT_FVF_NORMAL))		size += sizeof(sGT_FVF_NORMAL);
	else if(IsFVF(GT_FVF_DIFFUSE))  size += sizeof(sGT_FVF_DIFFUSE);
	else if(IsFVF(GT_FVF_SPECULAR)) size += sizeof(sGT_FVF_SPECULAR);

	int Flag = ((_value & GT_FVF_TEXCOUNT_MASK) >> GT_FVF_TEXCOUNT_SHIFT);

	for(int i = 0; i < Flag; i++)
	{
		if(_value & GT_FVF_TEXCOORDSIZE3(i)) size += sizeof(float) * 3;
		else if(_value & GT_FVF_TEXCOORDSIZE4(i)) size += sizeof(float) * 4;
		else if(_value & GT_FVF_TEXCOORDSIZE1(i)) size += sizeof(float) * 1;
		// ̰  ̾ Ѵ. Ʈ 2̱ ̴.
		// GT_FVF_TEXCOORDSIZE2 0̱   &ϸ 0 ´.
		//  GT_FVF_TEXCOORDSIZE  ϸ GT_FVF_TEXCOORDSIZE2 Ѵ.
		else if(!(_value & GT_FVF_TEXCOORDSIZE2(i))) size += sizeof(float) * 2;
	}

	return size;
}

int GtFVF::FVF_Get_SizeOf(unsigned long _FVF)
{
	static int size;

	switch(_FVF)
	{
	case  GT_FVF_RESERVED0 :		return 0;
	case  GT_FVF_POSITION_MASK :	return 0;
	case  GT_FVF_XYZ :				return sizeof(sGT_FVF_XYZ);
	case  GT_FVF_XYZRHW :			return sizeof(sGT_FVF_XYZRHW);
	case  GT_FVF_XYZB1 :			return sizeof(sGT_FVF_XYZB1);
	case  GT_FVF_XYZB2 :			return sizeof(sGT_FVF_XYZB2);
	case  GT_FVF_XYZB3 :			return sizeof(sGT_FVF_XYZB3);
	case  GT_FVF_XYZB4 :			return sizeof(sGT_FVF_XYZB4);
	case  GT_FVF_XYZB5 :			return sizeof(sGT_FVF_XYZB5);
	case  GT_FVF_XYZW :				return 0;

	case  GT_FVF_NORMAL :			return sizeof(sGT_FVF_NORMAL);
	case  GT_FVF_PSIZE :			return 0;
	case  GT_FVF_DIFFUSE :			return sizeof(sGT_FVF_DIFFUSE);
	case  GT_FVF_SPECULAR :			return sizeof(sGT_FVF_SPECULAR);

	case  GT_FVF_TEX0 :
	case  GT_FVF_TEX1 :
	case  GT_FVF_TEX2 :
	case  GT_FVF_TEX3 :
	case  GT_FVF_TEX4 :
	case  GT_FVF_TEX5 :
	case  GT_FVF_TEX6 :
	case  GT_FVF_TEX7 :
	case  GT_FVF_TEX8 :
		{
			int Flag = ((_FVF & GT_FVF_TEXCOUNT_MASK) >> GT_FVF_TEXCOUNT_SHIFT);

			for(int i = 0,size = 0; i < Flag; i++)
			{
				if     (_FVF & GT_FVF_TEXCOORDSIZE3(i)) size += sizeof(float) * 3;
				else if(_FVF & GT_FVF_TEXCOORDSIZE4(i)) size += sizeof(float) * 4;
				else if(_FVF & GT_FVF_TEXCOORDSIZE1(i)) size += sizeof(float) * 1;
				else if(!(_FVF & GT_FVF_TEXCOORDSIZE2(i))) size += sizeof(float) * 2;
			}
		}
		return size;

	case  GT_FVF_LASTBETA_UBYTE4 :
	case  GT_FVF_LASTBETA_D3DCOLOR :

	case  GT_FVF_RESERVED2 :
		return 0;
	}
	return 0;
}


//  Ϳ FVF Ӽ   Ӽ ͷ ̵
//  FVF,  FVF, ޽ FVF Ӽ,   
void* GtFVF::NextValue(unsigned long _Start_FVF_Flag,unsigned long _Target_FVF_Flag)
{
	if(!(IsFVF(_Target_FVF_Flag))) return false;

	int _front_Off = 0;
	for(unsigned long i = _Start_FVF_Flag ? _Start_FVF_Flag : 1; i < _Target_FVF_Flag; i <<= 1)
	{
		if((IsFVF(i))) _front_Off += FVF_Get_SizeOf(i);
	}

	m_pCalc += _front_Off;

	return m_pCalc;
}

void GtFVF::NextNode(void)
{ 
	m_pCalc = m_pNext += m_FVF_Size;
}; //   ̵

void GtFVF::ResetPtr(void)
{ 
	m_pNext = m_pCalc = (char*)m_pOriginal;
}  // ٽ óġ ͸ ̵Ѵ. 
void GtFVF::ReMakePtr(void* _Ptr) // FVF ٽ Ѵ.
{
	if(!_Ptr) assert(0);

	m_pOriginal = _Ptr;
	m_pNext = m_pCalc = (char*) _Ptr;
}
void GtFVF::ReMakeFVF(unsigned long _FVF_VALUE)
{ 
	m_FVF_Value = _FVF_VALUE; m_FVF_Size = FVF_Get_Total_Size(_FVF_VALUE);
}
bool GtFVF::IsFVF(unsigned long FVF_Flag)
{
	if(FVF_Flag & m_FVF_Value)
		return true; 
	
	return false; 
}

const unsigned long GtFVF::GetFVF(void)
{ 
	return m_FVF_Value;
}
