#include "GtFrustum.h"

//////////////////////////////////////////////////////////////////////////
/// 6  .
///  Ҳ  ü θ ٶ󺸴° ƴϰ ܺθ ٶ󺸰 ִ.
bool GtFrustum::MakeFrustum(GtMatrix4 &matView, GtMatrix4 &matProj)
{
	static GtMatrix4 mInvVProj;
	
	/*
		 ı ġ  ǥ  (-1,-1,0) ~ (1,1,1) ̿  ٲ.
		  谪 ־ش.
	*/
	m_ptFrustumPoint[0].x = -1.0f;	m_ptFrustumPoint[0].y = -1.0f;	m_ptFrustumPoint[0].z = 0.0f;
	m_ptFrustumPoint[1].x =  1.0f;	m_ptFrustumPoint[1].y = -1.0f;	m_ptFrustumPoint[1].z = 0.0f;
	m_ptFrustumPoint[2].x =  1.0f;	m_ptFrustumPoint[2].y = -1.0f;	m_ptFrustumPoint[2].z = 1.0f;
	m_ptFrustumPoint[3].x = -1.0f;	m_ptFrustumPoint[3].y = -1.0f;	m_ptFrustumPoint[3].z = 1.0f;
	m_ptFrustumPoint[4].x = -1.0f;	m_ptFrustumPoint[4].y =  1.0f;	m_ptFrustumPoint[4].z = 0.0f;
	m_ptFrustumPoint[5].x =  1.0f;	m_ptFrustumPoint[5].y =  1.0f;	m_ptFrustumPoint[5].z = 0.0f;
	m_ptFrustumPoint[6].x =  1.0f;	m_ptFrustumPoint[6].y =  1.0f;	m_ptFrustumPoint[6].z = 1.0f;
	m_ptFrustumPoint[7].x = -1.0f;	m_ptFrustumPoint[7].y =  1.0f;	m_ptFrustumPoint[7].z = 1.0f;

	//  Ѵ
	mInvVProj = (matView * matProj).MakeInverse();

	for(int i = 0; i < 8; i++)
	{
		m_ptFrustumPoint[i].TransformCoordRow(mInvVProj);
	}

	m_Plane[0].PlaneFromPoints(m_ptFrustumPoint[4],m_ptFrustumPoint[7],m_ptFrustumPoint[6]); // 
	m_Plane[1].PlaneFromPoints(m_ptFrustumPoint[0],m_ptFrustumPoint[1],m_ptFrustumPoint[2]); // 
	m_Plane[2].PlaneFromPoints(m_ptFrustumPoint[0],m_ptFrustumPoint[4],m_ptFrustumPoint[5]); //  (near)
	m_Plane[3].PlaneFromPoints(m_ptFrustumPoint[2],m_ptFrustumPoint[6],m_ptFrustumPoint[7]); //  (far)
	m_Plane[4].PlaneFromPoints(m_ptFrustumPoint[0],m_ptFrustumPoint[3],m_ptFrustumPoint[7]); // 
	m_Plane[5].PlaneFromPoints(m_ptFrustumPoint[1],m_ptFrustumPoint[5],m_ptFrustumPoint[6]); // 

	return true;
}

//------------------------------------------------------------------------
// Լ  : int StateSphereFrustum(sSphere& _in)
//     :  ü 踦 
//     : _in ˻ 
//   : 0 -  ü  
//           1 -  ü 浹 Ͽ.
//           2 -  ü ο ִ.
//     : , ü  浹ϴ ˻Ѵ.
//           浹ϸ װ .
//           ״, ü   踦 ˻Ѵ.
//           Check  6̻    Ʈ
//           ȿ ִٴ  ȴ.
//            ˻縦    ü ܺο ִ.
//------------------------------------------------------------------------
int GtFrustum::StateSphereFrustum(GtSphere &in)
{
	int i,Check;
	for(i = 0; i < 6; i++)
		if(CollisionSphereWithPlane(m_Plane[i],in))
			return 1;

	for(i = 0,Check = 0; i < 6; i++)
	{
		if(m_Plane[i].DotCoord(in.v) < 0)
			++Check;
	}
	
	if(Check >= 6) return 2;

	return 0;
}

//------------------------------------------------------------------------
// Լ  : bool StatePolygonFrustum(Vector3& _a,Vector3& _b,Vector3& _c)
//     :  ü 踦 
//     : _a,_b,_c -   1,2,3
//   :  (_a,_b,_c) ϳ ü ȿ  true,
//           ϳ  false 
//------------------------------------------------------------------------
bool GtFrustum::StatePolygonFrustum(GtPoint3f &_a, GtPoint3f &_b, GtPoint3f &_c)
{
	int a = 0,b = 0,c = 0;

	for(int i = 0; i < 6; i++)
	{
		if(m_Plane[i].DotCoord(_a) < 0) ++a;
		if(m_Plane[i].DotCoord(_b) < 0) ++b;
		if(m_Plane[i].DotCoord(_c) < 0) ++c;
	}

	if((a >= 6) | (b >= 6) | (c >= 6)) 
		return true; 

	return false;
}