#pragma once

#include "GtLib.h"

#ifndef __SPU__
const float GT_INFINITY = FLT_MAX;
const float GT_PI = 3.1415926535897932f;
const float GT_HALF_PI = 0.5f * GT_PI;
const float GT_TWO_PI = 2.0f * GT_PI;
#else
#define GT_INFINITY FLT_MAX
#define GT_PI       3.1415926535897932f
#define GT_HALF_PI  1.5707963267948966f;
#define GT_TWO_PI   6.2831853071795865f;
#endif


// 'float'  ϴ ⺻  Լ
float GtAbs(float fValue);
float GtACos(float fValue);
float GtASin(float fValue);
float GtTanf(float fValue);
float GtATan(float fValue);
float GtATan2(float fNumerator, float fDenominator);
float GtCos(float fRadians);
float GtExp(float fValue);
float GtFloor(float fValue);
float GtFmod(float fNumerator, float fDenominator);
float GtLog(float fValue);
float GtPow(float fBase, float fExponent);
float GtSign(float fValue);
float GtSin(float fRadians);
void GtSinCos(float fRadians, float& fSin, float& fCos);
float GtSqr(float fValue);
float GtSqrt(float fValue);

// ִ밪, ּҰ clamp
float GtMin(float fA, float fB);
float GtMax(float fA, float fB);
float GtClamp(float fValue, float fMin, float fMax);
int GtMin(int iA, int iB);
int GtMax(int iA, int iB);
int GtClamp(int iValue, int iMin, int iMax);

//  Լ
#define GtLerp(T, START, FINISH) ((START) + ((T) * ((FINISH) - (START))))
#define M_1_PI	0.31830988618379067154 
#define GtRadToDeg(T)	T * (180.f / GT_PI) //    
#define GtDegToRad(T)	T * (GT_PI / 180.f) //    
#define RadToDeg	(180.f / GT_PI)			//    
#define DegToRad	(GT_PI / 180.f)			//    


//   
void GtSrand(unsigned int uiSeed);
int GtRand();					// r in [0, RAND_MAX]
float GtSymmetricRandom();		// r in [-1, 1]
float GtUnitRandom();			// r in [0, 1]

// fast Լ
unsigned int GtFastLog(unsigned int uiNum);
float GtFastInvSqrt(float fValue);
float GtFastSqrt(float fValue);
float GtFastATan2(float fY, float fX);

#include "GtMath.inl"