
//------------------------------------------------------------------------------------
// 밪
inline float GtAbs(float fValue)
{
	return float(fabs(fValue));
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
// Cos  
inline float GtACos(float fValue)
{
	if( -1.0f < fValue)
	{
		if( fValue < 1.0f)
			return float(acos(fValue));
		else
			return 0.0f;
	}
	else
	{
		return GT_PI;
	}
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
// Sin 
inline float GtASin(float fValue)
{
	if( -1.0f < fValue)
	{
		if(fValue < 1.0f)
			return float(asin(fValue));
		else
			return GT_HALF_PI;
	}
	else
	{
			return -GT_HALF_PI;
	}
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline float GtTanf(float fValue)
{
	return tanf(fValue);
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline float GtATan(float fValue)
{
	return float(atan(fValue));
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline float GtATan2(float fNumerator, float fDenominator)
{
	return float(atan2(fNumerator, fDenominator));
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline float GtCos(float fRadians)
{
	return float(cos(fRadians));
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
//Լ Ѵ.
inline float GtExp(float fValue)
{
	return float(exp(fValue));
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
//μ fValue fValue ũ ʴ   Ѵ.
inline float GtFloor(float fValue)
{
	return float(floor(fValue));
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
//Ǽ fNumerator fDenominator    Ѵ.
inline float GtFmod(float fNumerator, float fDenominator)
{
	return float(fmod(fNumerator, fDenominator));
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
//  e ڿ α׸ Ѵ.
inline float GtLog(float fValue)
{
	return float(log(fValue));
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
// x y Ѵ.
inline float GtPow(float fBase, float fExponent)
{
	return float(pow(fBase, fExponent));
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline float GtSign(float fValue)
{
	return (fValue > 0.0f ? +1.0f :(fValue < 0.0f ? -1.0f : 0.0f) );
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline float GtSin(float fRadians)
{
	return float(sin(fRadians));
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline void GtSinCos(float fRadians, float &fSin, float &fCos)
{
    float s, c;
    __asm fld fRadians
    __asm fsincos
    __asm fstp c
    __asm fstp s

	fSin = s;
	fCos = c;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
//fValue 
inline float GtSqr(float fValue)
{
	return fValue*fValue;
}
//-----------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
// ϱ
inline float GtSqrt(float fValue)
{
	return float(sqrt(fValue));
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
//ּҰ
inline float GtMin(float fA, float fB)
{
	return (fA < fB) ? fA : fB;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline float GtMax(float fA, float fB)
{
	return (fA > fB) ? fA : fB;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline float GtClamp(float iValue, float iMin, float iMax)
{
	iValue = GtMax(iValue, iMin);
	iValue = GtMin(iValue, iMax);
	return iValue;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline int GtMin(int iA, int iB)
{
    return (iA < iB) ? iA : iB;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline int GtMax(int iA, int iB)
{
    return (iA > iB) ? iA : iB;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline int GtClamp(int iValue, int iMin, int iMax)
{
	iValue = GtMax(iValue, iMin);
	iValue = GtMin(iValue, iMax);
	return iValue;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline void GtSrand(unsigned int uiSeed)
{
	srand(uiSeed);
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline int GtRand()
{
	return rand();
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline float GtUnitRandom()
{
	return float(GtRand())/float(RAND_MAX);
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline float GtSymmetricRandom()
{
	return -1.0f + 2.0f * float(GtRand())/float(RAND_MAX);
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline unsigned int GtFastLog(unsigned int uiNum)
{
	unsigned int uiLog = 0;
	unsigned int uiTemp = uiNum >> 1;
	while( uiTemp & 0xffffffff )
	{
		uiTemp >>= 1;
		uiLog++;
	}

	return uiLog;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline float GtFastInvSqrt(float fValue)
{
	float fHalf = 0.5f * fValue;
	int i = *(int*)&fValue;
    i = 0x5f3759df - (i >> 1);
    fValue = *(float*)&i;
    fValue = fValue*(1.5f - fHalf*fValue*fValue);
    return fValue;
}
//------------------------------------------------------------------------------------
inline float GtFastSqrt(float fValue)
{
	return GtFastInvSqrt(fValue) * fValue;
}
//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------
inline float GtFastATan2(float fY, float fX)
{
    // Poly approximation valid for |z| <= 1.  To compute ATAN(z)
    // for z > 1, use ATAN(z) = PI/2 - ATAN(1/z).  For z < -1, use
    // ATAN(z) = -PI/2 - ATAN(1/z).

    if (fX == 0.0f && fY == 0.0f)
        return 0.0f;

    float fOffset = 0.0f;
    float fZ;
    if (GtAbs(fY) > GtAbs(fX))
    {
        //  |fY/fX| > 1 so use 1/z identities.
        fZ = fX / fY;
        if (fZ > 0.0f)
        {
            fOffset = GT_HALF_PI;
        }
        else if (fZ < 0.0f)
        {
            fOffset = -GT_HALF_PI;
        }
        else // fZ == 0.0f
        {
            // special case for 90deg and -90deg
            return (fY > 0.0f) ? GT_HALF_PI : -GT_HALF_PI;
        }
    }
    else
    {
        fZ = fY / fX;

        if (fZ == 0.0f)
        {
            // special case for 0deg and 180deg
            return (fX > 0.0f) ? 0.0f : GT_PI;
        }
    }

    float fZ2 = fZ * fZ;

    // Polynomial approximation of degree 9, P(z).

    float fResult;
    fResult = 0.0208351f;
    fResult *= fZ2;
    fResult -= 0.0851330f;
    fResult *= fZ2;
    fResult += 0.1801410f;
    fResult *= fZ2;
    fResult -= 0.3302995f;
    fResult *= fZ2;
    fResult += 0.9998660f;
    fResult *= fZ;

    if (fOffset)
        fResult = fOffset - fResult;

    // find proper solution to two arg arctan
    if (fY < 0.0f && fX < 0.0f)  // quadrant IV
        fResult -= GT_PI;
    if (fY > 0.0f && fX < 0.0f)  // quadrant II
        fResult += GT_PI;

    return fResult;
}
//------------------------------------------------------------------------------------