#pragma once

#include"GtPoint3.h"

#define PLANE_EPSILON 5.0f

class GtPlane
{
public:
	union
	{
		struct
		{
			GtPoint3f pt;
			float dist;
		};
		struct
		{
			float a, b, c, d;
		};
		float p[4];
	};
	//  3D  , 3D  4°     ʴ´.
	float Dot(GtPoint3f& pt) const;
	//  3D  , 3D  4°   1̶ Ѵ.
	float DotCoord(GtPoint3f& pt) const;
	//  3D  , 3D  4°   0̶ Ѵ
	float DotNormal(GtPoint3f& pt) const;
	// 鿡  Ϳ 鿡 ԵǴ   Ѵ.
	void  PlaneFromPointNormal(const GtPoint3f& normal,const GtPoint3f& pt);
	// 3   Ѵ.
	void  PlaneFromPoints(const GtPoint3f& _a,const GtPoint3f& _b,const GtPoint3f& _c);
	//    Ѵ.
	void  PlaneIntersectLine(GtPoint3f* pOut,GtPoint3f& p1,GtPoint3f& p2);
	//  ȭ (ڱڽ)
	void  Normalize(void);
	//  ȭ (ӽ  ȭ  )
	GtPlane Normalized(void);
	//  ´.
	void  Flip(void);

	//  + 
	GtPlane  operator  + () const;
	//  - 
	GtPlane  operator  - () const;

	// Ͱ  ˻
	bool   operator == (const GtPlane& _in) const;
	// Ͱ   ˻
	bool   operator != (const GtPlane& _in) const;
	//  
	GtPlane& operator  = (const GtPlane& _in);

	// Ʈ 
	GtPlane(const float _a = 0.f,const float _b = 0.f,const float _c = 0.f,const float _d = 0.f);
	//  
	GtPlane(const GtPlane& _in);
	// 鿡  Ϳ 鿡 ԵǴ   Ѵ.
	GtPlane(const GtPoint3f& _n,const GtPoint3f _d);
	// 3 ͷ  ϴ 
	GtPlane(const GtPoint3f& _a, const GtPoint3f& _b, const GtPoint3f& _c);
};