#pragma once

#include"GtMath.h"
#include"GtPoint3.h"

template<typename T>
class GtPoint4
{
public:
	inline GtPoint4<T> ();
	inline GtPoint4<T> (T tX, T tY, T tZ, T tW);
	inline GtPoint4<T> (const GtPoint3<T>& pt, T fW = 1.0f);

//	inline GtPoint4<T>(XMVECTOR vPt);

//	inline operator const XMVECTOR () const { return m_vfPt; }

	inline void MakeZero();
	inline void Set(T tX, T tY, T tZ, T tW);
	// GtPoint3 ̿ GtPoint4 
	inline void Set(const GtPoint3<T>& pt, T tW);

	inline void Set3VectorW0(const GtPoint3<T>& pt);
	inline void Set3VectorW0(T tX, T tY, T tZ);
	
	//  
	inline T operator[](int i) const;
	inline T Set(unsigned int uiComponent, T tValuve);
	inline T X() const;
	inline T Y() const;
	inline T Z() const;
	inline T W() const;
	
	inline void SetX(T tX);
	inline void SetY(T tY);
	inline void SetZ(T tZ);
	inline void SetW(T tW);

	inline GtPoint4<T> operator -() const;
	inline GtPoint4<T> operator +(const GtPoint4<T>& pt) const;
	inline GtPoint4<T> operator -(const GtPoint4<T>& pt) const;
	inline GtPoint4<T> operator *(T tScalar) const;
	inline GtPoint4<T> operator /(T tScalar) const;

	inline GtPoint4<T> operator +=(const GtPoint4<T>& pt);
	inline GtPoint4<T> operator -=(const GtPoint4<T>& pt);
	inline GtPoint4<T> operator *=(T tScalar);
	inline GtPoint4<T> operator /=(T tScalar);

	inline bool operator ==(const GtPoint4<T>& pt) const;
	inline bool operator !=(const GtPoint4<T>& pt) const;

	void CompressNormalizedIntoXY(const GtPoint3<T>& pt);
	void CompressNormalizedIntoZW(const GtPoint3<T>& pt);

	void DecompressXYIntoNormalized(GtPoint3<T>& pt);
	void DecompressZWIntoNormalized(GtPoint3<T>& pt);

	void DecompressHighDetailIntoNormalized(GtPoint3<T>& pt);

	union
	{
		T m_afPt[4];
	};
};

typedef GtPoint4<int>		GtPoint4i;
typedef GtPoint4<float>		GtPoint4f;

#include "GtPoint4.inl"