#include <math.h>
#include <stdio.h>
#include "GtSoftwareRenderer.h"

GtSoftwareRenderer::GtSoftwareRenderer(void) :
m_bIsActive(FALSE),
m_bIsDIB(FALSE),
m_hScreenDC(NULL),
m_hMemoryDC(NULL),
m_hBitmap(NULL),
m_hDefaultBitmap(NULL),
m_pBits(NULL),
m_iWidth(0),
m_iHeight(0),
m_iScanLine(0)
{
}

GtSoftwareRenderer::~GtSoftwareRenderer(void)
{
}

BOOL GtSoftwareRenderer::SetupSoftware(HWND hWnd, int iWidth, int iHeight)
{
	// ȭ DC 
	m_hScreenDC = GetDC(hWnd);
	// ȭ DC  
	m_hMemoryDC = CreateCompatibleDC(m_hScreenDC);
	// DIB Ʈڵ 
	MakeDIBSection(m_hScreenDC, iWidth, iHeight, &m_pBits);

	//  hBitmap  ϱ ϰ  HBITMAP س
	m_hDefaultBitmap = (HBITMAP)SelectObject(m_hMemoryDC, m_hBitmap);

	SetActive(TRUE);

	this->InitFrameTimer();

	return TRUE;
}

BOOL GtSoftwareRenderer::CloseSoftware(HWND hWnd)
{
	//  HBITMAP 
	SelectObject(m_hMemoryDC, m_hDefaultBitmap);
	// MemDC
	DeleteDC(m_hMemoryDC);
	// HBITMAP
	DeleteObject(m_hDefaultBitmap);
	DeleteObject(m_hBitmap);

	//ũDC 
	ReleaseDC(hWnd, m_hScreenDC);

	SetActive(FALSE);

	return TRUE;
}

BOOL GtSoftwareRenderer::MakeDIBSection(HDC hDC, int iWidth, int iHeight, BYTE **pBits)
{	
	// 24Ʈ Ʈ 
	BITMAPINFO _BMInfo;

	_BMInfo.bmiHeader.biSize			= sizeof (BITMAPINFOHEADER);
	_BMInfo.bmiHeader.biWidth			= iWidth;
	_BMInfo.bmiHeader.biHeight			= -iHeight;
	_BMInfo.bmiHeader.biPlanes			= 1;
	_BMInfo.bmiHeader.biBitCount		= 24;
	_BMInfo.bmiHeader.biCompression		= BI_RGB;
	_BMInfo.bmiHeader.biSizeImage		= 0;
	_BMInfo.bmiHeader.biXPelsPerMeter	= 0;
	_BMInfo.bmiHeader.biYPelsPerMeter	= 0;
	_BMInfo.bmiHeader.biClrUsed			= 0;
	_BMInfo.bmiHeader.biClrImportant	= 0;

	m_hBitmap = CreateDIBSection(hDC, (BITMAPINFO *)&_BMInfo, DIB_RGB_COLORS, (VOID **)pBits, NULL, 0);
	
	m_iScanLine = (iWidth * 3 + 3)/4 * 4;
	m_iWidth = iWidth;
	m_iHeight = iHeight;

	if(!m_hBitmap)
		return FALSE;

	return TRUE;
}

// PutPixel
void GtSoftwareRenderer::PutPixel(int x, int y, int r, int g, int b)
{
	int _offset = y * m_iScanLine + x * 3;

	m_pBits[_offset + 0] = b;
	m_pBits[_offset + 1] = g;
	m_pBits[_offset + 2] = r;
}

void GtSoftwareRenderer::LineDDAFloatPoint(int x1, int y1, int x2, int y2, int r, int g, int b)
{
	POINT _pt1, _pt2;
	_pt1.x = x1;
	_pt1.y = y1;
	_pt2.x = x2;
	_pt2.y = y2;
	if(ClipLine(&_pt1, &_pt2))
		return;
	float	_x, _y;			// ӽ 
	int		_dx, _dy;			// x, y ̰
	int		_x_inc, _y_inc;		// x, y 

	_dx = x2 - x1;
	_dy = y2 - y1;
	
	// dx 0 ũų  x 3
	if(_dx>=0)
	{
		_x_inc = 3;
	}
	else
	{
		_x_inc = -3;
		_dx = -_dx;
	}

	// dx 0 ũų  y g_scanline
	if(_dy>=0)
	{
		_y_inc = m_iScanLine;
	}
	else
	{
		_y_inc = -m_iScanLine;
		_dy = -_dy;
	}

	// ӽú x,y ʱȭ
	_x = (float)x1;
	_y = (float)y1;

	// offset ʱȭ
	int _offset = x1 * 3 + (m_iScanLine * y1);

	// Ⱑ 1  y ⸦ Ͽ  ã´
	if(_dx>_dy)
	{
		//  
		float _m = (float)fabs((float)(y2 - y1) / (x2 - x1 ));
		// dxŭ 
		for(int i=0; i<_dx; ++i)
		{
			//  ´.
			m_pBits[_offset]   = b;
			m_pBits[_offset+1] = g;
			m_pBits[_offset+2] = r;

			// x 
			_offset += _x_inc;

			// ⸦  y 1  y1 Ͽ
			// offset y Ұ 
			if(_y > (float)y1)
			{
				_offset += _y_inc;
				++y1;
			}
			_y += _m;
		}
	}
	// Ⱑ 1 ũų  x ⸦ Ͽ  ã´
	else
	{
		float _m = (float)fabs((float)(x2 - x1) / (y2 - y1 ));
		for(int i=0; i<_dy; ++i)
		{
			m_pBits[_offset]   = b;
			m_pBits[_offset+1] = g;
			m_pBits[_offset+2] = r;
			_offset += _y_inc;
			if(_x > (float)(x1))
			{
				_offset += _x_inc;
				++x1;
			}
			_x += _m;
		}
	}
}

void GtSoftwareRenderer::LineDDAFixedPoint(int x1, int y1, int x2, int y2, int r, int g, int b)
{
	POINT _pt1, _pt2;
	_pt1.x = x1;
	_pt1.y = y1;
	_pt2.x = x2;
	_pt2.y = y2;
	if(!ClipLine(&_pt1, &_pt2))
		return;
	x1 = _pt1.x;
	y1 = _pt1.y;
	x2 = _pt2.x;
	y2 = _pt2.y;
	int _x, _y;
	int _dx, _dy;
	int _x_inc, _y_inc;

	_dx = x2 - x1;
	_dy = y2 - y1;
	
	if(_dx>=0)
	{
		_x_inc = 3;
	}
	else
	{
		_x_inc = -3;
		_dx = -_dx;
	}

	if(_dy>=0)
	{
		_y_inc = m_iScanLine;
	}
	else
	{
		_y_inc = -m_iScanLine;
		_dy = -_dy;
	}

	
	_x = x1<<16;
	_y = y1<<16;
	int _offset = x1 * 3 + (m_iScanLine * y1);

	if(_dx>_dy)
	{
		int _m = abs(((y2 - y1)<<16) / (x2 - x1));
		for(int i=0; i<_dx; ++i)
		{
			m_pBits[_offset  ] = b;
			m_pBits[_offset+1] = g;
			m_pBits[_offset+2] = r;
			_offset += _x_inc;
			if(_y > (y1<<16))
			{
				_offset += _y_inc;
				++y1;
			}
			_y += _m;
		}
	}
	else
	{
		int _m = abs(((x2 - x1)<<16) / (y2 - y1));
		for(int i=0; i<_dy; ++i)
		{
			m_pBits[_offset  ] = b;
			m_pBits[_offset+1] = g;
			m_pBits[_offset+2] = r;
			_offset += _y_inc;
			if(_x > (x1<<16))
			{
				_offset += _x_inc;
				++x1;
			}
			_x += _m;
		}
	}
}

//Clipping
BOOL GtSoftwareRenderer::ClipLine(POINT *p1, POINT *p2)
{
	POINT _ptPoint1, _ptPoint2;
	_ptPoint1.x = p1->x;
	_ptPoint1.y = p1->y;
	_ptPoint2.x = p2->x;
	_ptPoint2.y = p2->y;
	// üũ------------------------------------
	// r1:1   r2:2  
	int _r1 = 0, _r2 = 0;
	if(p1->y < 0)
		_r1 |= 8;
	if(p1->y > m_iHeight - 1)
		_r1 |= 4;

	if(p1->x < 0)
		_r1 |= 1;
	if(p1->x > m_iWidth - 1)
		_r1 |= 2;

	if(p2->y < 0)
		_r2 |= 8;
	if(p2->y > m_iHeight - 1)
		_r2 |= 4;

	if(p2->x < 0)
		_r2 |= 1;
	if(p2->x > m_iWidth - 1)
		_r2 |= 2;
	//--------------------------------------------

	// _r1 | _r2  0 ̸   ->  ߱ 
	if(!(_r1 || _r2))
		return TRUE;

	if(_r1 & _r2)
		return FALSE;
	
	switch(_r1)
	{
	case 0:
		break;
	case 1:
		_ptPoint1.x = 0;
		_ptPoint1.y = p1->y + (LONG)((float)(-p1->x) * (p2->y - p1->y) / (p2->x - p1->x) + 0.5f);
		break;
	case 2:
		_ptPoint1.x = m_iWidth - 1;
		_ptPoint1.y = p1->y + (LONG)((float)(_ptPoint1.x - p1->x) * (p2->y - p1->y) / (p2->x - p1->x) + 0.5f);
		break;
	case 4:
		_ptPoint1.y = m_iHeight - 1;
		_ptPoint1.x = p1->x + (LONG)((float)(_ptPoint1.y - p1->y) * (p2->x - p1->x) / (p2->y - p1->y) + 0.5f);
		break;
	case 5:
		_ptPoint1.y = m_iHeight - 1;
		_ptPoint1.x = p1->x + (LONG)((float)(_ptPoint1.y - p1->y) * (p2->x - p1->x) / (p2->y - p1->y) + 0.5f);
		if(_ptPoint1.x < 0)
		{
			_ptPoint1.x = 0;
			_ptPoint1.y = p1->y + (LONG)((float)(-p1->x) * (p2->y - p1->y) / (p2->x - p1->x) + 0.5f);
		}
		break;
	case 6:
		_ptPoint1.y = m_iHeight - 1;
		_ptPoint1.x = p1->x + (LONG)((float)(_ptPoint1.y - p1->y) * (p2->x - p1->x) / (p2->y - p1->y) + 0.5f);
		if(_ptPoint1.x > m_iWidth - 1)
		{
			_ptPoint1.x = m_iWidth - 1;
			_ptPoint1.y = p1->y + (LONG)((float)(_ptPoint1.x - p1->x) * (p2->y - p1->y) / (p2->x - p1->x) + 0.5f);
		}
		break;
	case 8:
		_ptPoint1.y = 0;
		_ptPoint1.x = p1->x + (LONG)((float)(-p1->y) * (p2->x - p1->x) / (p2->y - p1->y) + 0.5f);
		break;
	case 9:
		_ptPoint1.y = 0;
		_ptPoint1.x = p1->x + (LONG)((float)(-p1->y) * (p2->x - p1->x) / (p2->y - p1->y) + 0.5f);
		if(_ptPoint1.x < 0)
		{
			_ptPoint1.x = 0;
			_ptPoint1.y = p1->y + (LONG)((float)(-p1->x) * (p2->y - p1->y) / (p2->x - p1->x) + 0.5f);
		}
		break;
	case 10:
		_ptPoint1.y = 0;
		_ptPoint1.x = p1->x + (LONG)((float)(-p1->y) * (p2->x - p1->x) / (p2->y - p1->y) + 0.5f);
		if(_ptPoint1.x > m_iWidth - 1)
		{
			_ptPoint1.x = m_iWidth - 1;
			_ptPoint1.y = p1->y + (LONG)((float)(_ptPoint1.x - p1->x) * (p2->y - p1->y) / (p2->x - p1->x) + 0.5f);
		}
		break;
	}
	switch(_r2)
	{
	case 0:
		break;
	case 1:
		_ptPoint2.x = 0;
		_ptPoint2.y = p2->y + (LONG)((float)(-p2->x) * (p1->y - p2->y) / (p1->x - p2->x) + 0.5f );
		break;
	case 2:
		_ptPoint2.x = m_iWidth - 1;
		_ptPoint2.y = p2->y + (LONG)((float)(_ptPoint2.x - p2->x) * (p1->y - p2->y) / (p1->x - p2->x) + 0.5f );
		break;
	case 4:
		_ptPoint2.y = m_iHeight - 1;
		_ptPoint2.x = p2->x + (LONG)((float)(_ptPoint2.y - p2->y) * (p1->x - p2->x) / (p1->y - p2->y) + 0.5f );
		break;
	case 5:
		_ptPoint2.y = m_iHeight - 1;
		_ptPoint2.x = p2->x + (LONG)((float)(_ptPoint2.y - p2->y) * (p1->x - p2->x) / (p1->y - p2->y) + 0.5f );
		if(_ptPoint2.x < 0)
		{
			_ptPoint2.x = 0;
			_ptPoint2.y = p2->y + (LONG)((float)(-p2->x) * (p1->y - p2->y) / (p1->x - p2->x) + 0.5f );
		}
		break;
	case 6:
		_ptPoint2.y = m_iHeight - 1;
		_ptPoint2.x = p2->x + (LONG)((float)(_ptPoint2.y - p2->y) * (p1->x - p2->x) / (p1->y - p2->y) + 0.5f );
		if(_ptPoint2.x > m_iWidth - 1)
		{
			_ptPoint2.x = m_iWidth - 1;
			_ptPoint2.y = p2->y + (LONG)((float)(_ptPoint2.x - p2->x) * (p1->y - p2->y) / (p1->x - p2->x) + 0.5f );
		}
		break;
	case 8:
		_ptPoint2.y = 0;
		_ptPoint2.x = p2->x + (LONG)((float)(-p2->y) * (p1->x - p2->x) / (p1->y - p2->y) + 0.5f );
		break;
	case 9:
		_ptPoint2.y = 0;
		_ptPoint2.x = p2->x + (LONG)((float)(-p2->y) * (p1->x - p2->x) / (p1->y - p2->y) + 0.5f );
		if(_ptPoint2.x < 0)
		{
			_ptPoint2.x = 0;
			_ptPoint2.y = p2->y + (LONG)((float)(-p2->x) * (p1->y - p2->y) / (p1->x - p2->x) + 0.5f );
		}
		break;
	case 10:
		_ptPoint2.y = 0;
		_ptPoint2.x = p2->x + (LONG)((float)(-p2->y) * (p1->x - p2->x) / (p1->y - p2->y) + 0.5f );
		if(_ptPoint2.x > m_iWidth - 1) 
		{
			_ptPoint2.x = m_iWidth - 1;
			_ptPoint2.y = p2->y + (LONG)((float)(_ptPoint2.x - p2->x) * (p1->y - p2->y) / (p1->x - p2->x) + 0.5f );
		}
		break;
	}

	if( _ptPoint1.x<0 || _ptPoint1.x >=m_iWidth || _ptPoint1.y <0 || _ptPoint1.y >= m_iHeight ||
		_ptPoint2.x<0 || _ptPoint2.x>=m_iWidth || _ptPoint2.y<0 || _ptPoint2.y >= m_iHeight )return FALSE;

	p1->x = _ptPoint1.x;
	p1->y = _ptPoint1.y;
	p2->x = _ptPoint2.x;
	p2->y = _ptPoint2.y;
	return TRUE;
}

void GtSoftwareRenderer::InitFrameTimer(void)
{
	m_fTimer	= 0.0f;
	m_fFPS		= 0.0f;
	QueryPerformanceFrequency(&m_iFrequency);
}

void GtSoftwareRenderer::FrameCheck(void)
{
	QueryPerformanceCounter(&m_iEnd);
	m_fTimer = (m_iEnd.LowPart - m_iStart.LowPart) / (float)m_iFrequency.LowPart;
	m_fFPS = 1 / m_fTimer;
	m_iStart = m_iEnd;
}


void GtSoftwareRenderer::Process(void)
{
	this->FrameCheck();
	char szText[128];
	sprintf(szText, "FPS : %f", m_fFPS);
	TextOut(m_hMemoryDC, 0, 0, szText, strlen(szText));

	// memory set
	memset( m_pBits, 0, sizeof( m_iWidth * m_iHeight * 3 ) );
	
	// memory  ȼ 
//	PutPixel(320, 240, 255, 0, 0);
}

void GtSoftwareRenderer::Render(void)
{
	//  ߱
	LineDDAFixedPoint( -100, -200, 600, 300, 255, 0, 255 );
	//  !
	BitBlt(m_hScreenDC, 0, 0, m_iWidth, m_iHeight, m_hMemoryDC, 0, 0, SRCCOPY);
}

/*void GtSoftwareRenderer::UpdateFrame(void)
{
	// memory set
	memset( m_pBits, 0, sizeof( m_iWidth * m_iHeight * 3 ) );
	
	// memory  ȼ 
	PutPixel(320, 240, 255, 0, 0);
	
	BitBlt(m_hScreenDC, 0, 0, m_iWidth, m_iHeight, m_hMemoryDC, 0, 0, SRCCOPY);
}*/

void GtSoftwareRenderer::SetActive(BOOL bActive)
{
	m_bIsActive = bActive;
}