#pragma once

#include <windows.h>

class GtSoftwareRenderer
{
private:
	BOOL			m_bIsActive;			// DIB   
	BOOL			m_bIsDIB;				
	
	HDC				m_hScreenDC;			// DC | ũ  ޸
	HDC				m_hMemoryDC;
	
	HBITMAP			m_hBitmap;				// ޸ DC  Ʈ ڵ
	HBITMAP			m_hDefaultBitmap;		//  Ʈ ڵ

	BYTE			*m_pBits;				// ޸ Ʈ ù° ּ(, κ  Ʈ  κ) Ű  
	
	int				m_iWidth;
	int				m_iHeight;

	int				m_iScanLine;			// Ʈ  (Ʈ)

	

	float			m_fTimer;
	float			m_fFPS;

	LARGE_INTEGER	m_iStart;
	LARGE_INTEGER	m_iEnd;
	LARGE_INTEGER	m_iFrequency;
private:
	BOOL			MakeDIBSection(HDC hDC, int iWidth, int iHeight, BYTE **pBits);

	void			SetActive(BOOL bActive);
public:
	GtSoftwareRenderer(void);
	~GtSoftwareRenderer(void);

	BOOL			SetupSoftware(HWND hWnd, int iWidth = 640, int iHeight = 480);
	BOOL			CloseSoftware(HWND hWnd);

	void			PutPixel(int x, int y, int r, int g, int b);
	void			LineDDAFloatPoint(int x1, int y1, int x2, int y2, int r, int g, int b);
	void			LineDDAFixedPoint(int x1, int y1, int x2, int y2, int r, int g, int b);
	BOOL			ClipLine(POINT *p1, POINT *p2);
//	void			UpdateFrame(void);								// ȭ 

	//	Frame ϱ ؼ
	void			InitFrameTimer(void);
	void			FrameCheck(void);


	void			Process(void);
	void			Render(void);

	BOOL			GetIsActive(void);
	BOOL			GetIsDIb(void);

	HDC				GetScreenDC(void);
	HDC				GetMemoryDC(void);
public:
	float			GetFPS(void)		{	return m_fFPS;	}
};