#include"GtWinClass.h"

GtWinClass *GtWinClass::m_spWinApp = NULL;

GtWinClass::GtWinClass(void) : 
m_bLoop(FALSE), 
m_hWnd(NULL), 
m_hInst(NULL), 
m_iWidth(0), 
m_iHeight(0),
m_lpszClass(NULL)
{
	m_spWinApp = this;
}

GtWinClass::~GtWinClass(void)
{
	UnregisterClass(m_lpszClass, m_hInst);
}

LRESULT CALLBACK GtWinClass::GtWinAppProc(HWND hWnd, UINT uiMessage, WPARAM wParam, LPARAM lParam)
{
	return m_spWinApp->WndProc(hWnd, uiMessage, wParam, lParam);
}

bool GtWinClass::Register(HINSTANCE hInstance, LPCTSTR lpszClass)
{
	m_hInst			= hInstance;
	m_lpszClass		= lpszClass;

	m_wWndClass.cbClsExtra			= 0;
	m_wWndClass.cbWndExtra			= 0;
	m_wWndClass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);//(HBRUSH)GetStockObject(COLOR_WINDOW+1);
	m_wWndClass.hCursor				= LoadCursor(NULL,IDC_ARROW);
	m_wWndClass.hIcon					= LoadIcon(NULL,IDI_APPLICATION);
	m_wWndClass.hInstance			= m_hInst;
	m_wWndClass.lpfnWndProc		= (WNDPROC)GtWinAppProc;
	m_wWndClass.lpszClassName	= m_lpszClass;
	m_wWndClass.lpszMenuName	= NULL;
	m_wWndClass.style						= CS_HREDRAW | CS_VREDRAW;

	RegisterClass(&m_wWndClass);
	return TRUE;
}

bool GtWinClass::Create(HWND hWnd, DWORD dwSize, DWORD dwStyle)
{
	m_hWnd		=	hWnd;
	RECT _rc		=	{ 0, };

	switch(dwSize)
	{
	case WIN_SIZE_640X480:
		m_iWidth = 640;
		m_iHeight = 480;
		break;
	case WIN_SIZE_800X600:
		m_iWidth = 800;
		m_iHeight = 600;
		break;
	case WIN_SIZE_1024X768:
		m_iWidth = 1024;
		m_iHeight = 768;
		break;
	default:
		m_iWidth = GetSystemMetrics(SM_CXSCREEN);
		m_iHeight = GetSystemMetrics(SM_CYSCREEN);
		break;
	}
	int _WinX = GetSystemMetrics(SM_CXSCREEN);
	int _WinY = GetSystemMetrics(SM_CYSCREEN);

	m_hWnd = CreateWindow(m_lpszClass, m_lpszClass, dwStyle, _WinX/2 - m_iWidth/2, _WinY/2 - m_iHeight/2, m_iWidth, m_iHeight, NULL, (HMENU)NULL, m_hInst, NULL);

	if(!m_hWnd)
		return FALSE;

	ShowWindow(m_hWnd, SW_SHOW);
	UpdateWindow(m_hWnd);
	ShowCursor(TRUE);

	SetClientSize(m_iWidth, m_iHeight);

	m_bLoop = TRUE;

	return TRUE;
}

void GtWinClass::SetClientSize(int iWidth, int iHeight)
{
	RECT rcClient, rcWindow;

	GetClientRect(m_hWnd, &rcClient);
	GetWindowRect(m_hWnd, &rcWindow);

	int dx = (rcWindow.right-rcWindow.left) - (rcClient.right-rcClient.left);
	int dy = (rcWindow.bottom-rcWindow.top) - (rcClient.bottom-rcClient.top);

	RECT Rect = { 0, 0, iWidth + dx, iHeight + dy };

	SetWindowPos(m_hWnd, NULL, 0, 0, Rect.right - Rect.left, Rect.bottom - Rect.top,
		SWP_NOZORDER | SWP_NOMOVE | SWP_NOACTIVATE);
}

LRESULT CALLBACK GtWinClass::WndProc(HWND hWnd, UINT uiMessage, WPARAM wParam, LPARAM lParam)
{
	switch(uiMessage)
	{
	case WM_DESTROY:
		m_bLoop = FALSE;
		PostQuitMessage(0);
		return 0;
	}

	return (DefWindowProc(hWnd, uiMessage, wParam, lParam));
}

bool GtWinClass::InitWinClass(void)
{
	return true;
}

bool GtWinClass::MsgLoop(void)
{
	while(m_bLoop)
	{
		if(PeekMessage(&m_mMsg, m_hWnd, 0, 0, PM_NOREMOVE))
		{
			if(!GetMessage(&m_mMsg, m_hWnd, 0, 0))
				break;

			TranslateMessage(&m_mMsg);
			DispatchMessage(&m_mMsg);	
		}
		else
		{
			//Loop
		}
	}

	return false;
}